"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const deploymentContracts_1 = require("../utils/deploymentContracts");
exports.token = ([, holding], _, context) => {
    return context.environment.getToken(holding.address);
};
exports.amount = ([, holding]) => {
    return holding.amount;
};
exports.valueInDenominationAsset = ([accounting, holding], _, context) => __awaiter(void 0, void 0, void 0, function* () {
    const denominationAsset = yield accounting.getDenominationAsset(context.block);
    // NOTE: This uses the current latest price source on purpose because any new assets
    // that might be added on a new release would otherwise not have a price on old
    // price feeds (e.g. if we used the price source registered on the hub).
    const source = deploymentContracts_1.priceFeedContract(context.environment);
    return source.convertQuantity(holding.amount, holding.address, denominationAsset, context.block);
});
